Girocco/Util.pm: allow bare '+' in URLs
[girocco.git] / jobd / gc.sh
blob84f0c57dca959eaf3be63ced6a77db6a955e501f
1 #!/bin/sh
3 # NOTE: additional options can be passed to git repack by specifying
4 # them after the project name, for example:
5 # gc.sh my-project -f
7 . @basedir@/shlib.sh
8 . @basedir@/jobd/gc-util-functions.sh
10 set -e
12 if [ $# -lt 1 ]; then
13 echo "Usage: gc.sh projname [extra-repack-args]" >&2
14 exit 1
17 # Includes
18 _shlib_done=1
19 unset GIROCCO_SUPPRESS_AUTO_GC_UPDATE
20 . "$cfg_basedir/jobd/maintain-auto-gc-hack.sh"
21 . "$cfg_basedir/jobd/generate-auto-gc-update.sh"
22 GIROCCO_SUPPRESS_AUTO_GC_UPDATE=1 && export GIROCCO_SUPPRESS_AUTO_GC_UPDATE
24 umask 002
25 [ "$cfg_permission_control" != "Hooks" ] || umask 000
26 clean_git_env
28 # The pre-receive script creates one ref log file per push but we want them to
29 # be coalesced into one ref log file per day. We are guaranteed that any files
30 # we find to coalesce are NOT currently being written to since they are always
31 # written first as temporary files and then moved into place. We attempt to
32 # transfer the most recent modification time to the coalesced log file which
33 # would step on its mod time if it were being written to directly, but if we
34 # find per-process ref log files then it must be a push project and the only
35 # thing that would write directly to the main per-day log file would be a
36 # mirror project so there's actually no conflict.
37 # Also, if the clock is wonky (or was futzed with) we may have both YYYYMMDD
38 # and YYYYMMDD.gz present in which case combine them into YYYYMMDD
39 coalesce_reflogs() {
40 [ -d reflogs ] || return 0
41 rm -f .gc_failed
42 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]" -print |
43 while read -r rname; do
44 if [ -e "$rname.gz" ]; then
45 if [ -s "$rname" ]; then
46 # Presumably the .gz file must have been created before the non-gz
47 # file since it had to be uncompressed at some point therefore
48 # we need to append the non-gz contents to it but keep the non-gz
49 # contents timestamp so we rename to YYYYMMDD_ which will sort first
50 # and be picked up in the next step if we are interrupted in the middle.
51 # If a YYYYMMDD_ file already exists we append to it and transfer the
52 # timestamp. Finally we transfer the YYYYMMDD_ timestamp to the result
53 # and remove the YYYYMMDD_ temporary file leaving the result uncompressed.
54 if [ -e "${rname}_" ]; then
55 cat "$rname" >>"${rname}_"
56 touch -r "$rname" "${rname}_"
57 rm -f "$rname"
58 ! [ -e "$rname" ]
59 else
60 mv "$rname" "${rname}_"
62 gzip -d "$rname.gz" </dev/null
63 [ -e "$rname" ] && ! [ -e "$rname.gz" ]
64 cat "${rname}_" >>"$rname"
65 touch -r "${rname}_" "$rname"
66 rm -f "${rname}_"
67 else
68 # Just remove the empty file to resolve the problem
69 rm -f "$rname"
72 done
73 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]_*" -print | LC_ALL=C sort |
74 while read -r rname; do
75 logname="${rname%%_*}"
76 # If someone's been futzing with the date, the file we want to
77 # append to could already have been compressed, so we just uncompress
78 # it here. The previous block guarantees we do not have both a compressed
79 # and uncompressed version present at the same time.
80 if [ -e "$logname.gz" ]; then
81 gzip -d "$logname.gz" </dev/null
82 [ -e "$logname" ] && ! [ -e "$logname.gz" ]
84 cat "$rname" >>"$logname"
85 touch -r "$rname" "$logname"
86 rm -f "$rname"
87 if [ -e "$rname" ]; then
88 >.gc_failed
89 echo "! [$proj] failed to remove $rname" >&2
90 exit 1 # will only exit subshell created by "|"
92 done
93 ! [ -e .gc_failed ]
96 # Remove any files in reflogs that are older than $cfg_reflogs_lifetime days
97 prune_reflogs() {
98 [ -d reflogs ] || return 0
99 exp="$(( ${cfg_reflogs_lifetime:-1} * 1440 ))"
100 [ $exp -gt 0 ] || exp=1440
101 [ $exp -le 43200 ] || exp=43200
102 find -L reflogs -maxdepth 1 -type f -mmin "+$exp" -exec rm -f '{}' + || :
105 # Compact any reflogs that are not today's UTC date unless a .gz version exists
106 compact_reflogs() {
107 [ -d reflogs ] || return 0
108 _td="reflogs/$(TZ=UTC date '+%Y%m%d')"
109 find -L reflogs -maxdepth 1 -type f -name "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]" -print |
110 while read -r rname; do
111 [ "$rname" != "$_td" ] || continue
112 ! [ -e "$rname.gz" ] || continue
113 gzip -9 "$rname" </dev/null
114 done
117 # return true if there's more than two objects/pack-<sha>.pack files or
118 # ANY sha-1 files in objects or
119 # there's one or two packs but at least one does not have a normal pack name or
120 # there's at least one pack but not any refs
121 is_dirty() {
122 _packs="$(find -L objects/pack -name "pre-auto-gc-[12].pack" -prune -o -name "*.pack" -type f -print 2>/dev/null | head -n 3)"
123 v_cnt _packscnt $_packs
124 if [ $_packscnt -gt 2 ]; then
125 return 0
127 if [ $_packscnt -gt 0 ]; then
128 for _pack in $_packs; do
129 _pack="${_pack%.pack}"
130 _pack="${_pack#objects/pack/}"
131 case "$_pack" in
132 pack-*)
133 _pack="${_pack#pack-}"
134 if [ "${#_pack}" -lt 40 ] || [ "${_pack#*[!0-9a-fA-F]}" != "$_pack" ]; then
135 # name not exclusively 40 or more hexadecimal digits makes it dirty
136 return 0
140 # abnormal name makes it dirty
141 return 0
143 esac
144 done
146 _objs=$(find -L objects/$octet -name "$octet19*" -type f -print 2>/dev/null | head -n 1 | LC_ALL=C wc -l)
147 [ $_objs -eq 0 ] || return 0
148 [ $_packscnt -gt 0 ] || return 1
149 # we do this check last because it's potentially the most expensive;
150 # at this point we know we do not have any loose objects, but we do
151 # have one or two packs that are named "normally"; empty refs => dirty
152 is_empty_refs_dir
155 # combine the input pack(s) into a new pack (or possibly packs if packSizeLimit set)
156 # input pack names are read from standard input one per line delimited by the first
157 # ':', ' ' or '\n' character on the line (which allows gfi-packs to be read directly)
158 # all arguments, if any, are passed to pack-objects as additional options
159 # returns non-zero on failure AND creates .gc_failed in that case
160 combine_packs() {
161 rm -f .gc_failed
162 combine_packs_std "$@" || {
163 >.gc_failed
164 return 1
166 return 0
169 # if the current directory is_gfi_mirror then repack all packs listed in gfi-packs
170 repack_gfi_packs() {
171 [ -n "$gfi_mirror" ] || return 0
172 [ -d objects/pack ] || { rm -f gfi-packs; return 0; }
173 progress "~ [$proj] redeltifying poor quality git fast-import packs"
174 combine_packs --ignore-missing --no-reuse-delta <gfi-packs
175 rm -f gfi-packs
176 return 0
179 # pack any existing loose objects into a new _l.pack file then run prune-packed
180 # note that prune-packed is NOT run beforehand -- the caller must do that if needed
181 # loose objects need not be part of complete commits/trees as --weak-naming is used
182 pack_loose_objects() {
183 _lpacks="$(run_combine_packs </dev/null --names --loose --weak-naming --non-empty --all-progress-implied ${quiet:---progress} $packopts)"
184 if [ -n "$_lpacks" ]; then
185 # We need to identify these packs later so we don't combine_packs them
186 for _objpack in $_lpacks; do
187 rename_pack "objects/pack/pack-$_objpack" "objects/pack/pack-${_objpack}_l" || :
188 done
189 git prune-packed $quiet
193 # combine small packs into larger pack(s)
194 # we avoid any _[lo], keep, bndl or bitmap packs
195 # if the optional argument is non-empty even a single small pack will be redeltad
196 combine_small_packs() {
197 _didprogress=
198 _minsmallpacks=2
199 if [ -n "$1" ] && [ -n "$noreusedeltaopt" ]; then
200 _minsmallpacks=1
202 _lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl"
203 _lpo="$_lpo --exclude-sfx _u --exclude-sfx _o --exclude-sfx _l"
204 _lpo="$_lpo --quiet --object-limit $var_redelta_threshold objects/pack"
205 while
206 _cnt="$(list_packs --count $_lpo)" || :
207 test "${_cnt:-0}" -ge $_minsmallpacks
209 [ -n "$_didprogress" ] || {
210 progress "~ [$proj] combining small packs into a single larger pack"
211 _didprogress=1
213 _newp="$(list_packs $_lpo | combine_packs --names $noreusedeltaopt)"
214 v_cnt _newc $_newp
215 # be paranoid and exit the loop if we haven't reduced the number of packs
216 [ $_newc -lt $_cnt ] || break
217 _minsmallpacks=2
218 done
219 return 0
222 # combine small _l packs into larger pack(s) using --weak-naming
223 # we avoid any non _l, keep, bndl or bitmap packs
224 # if the optional 2nd argument is non-empty even a single small pack will be redeltad
225 combine_small_loose_packs() {
226 _didprogress=
227 _minsmallpacks=2
228 if [ -n "$1" ] && [ -n "$noreusedeltaopt" ]; then
229 _minsmallpacks=1
231 _lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl"
232 _lpo="$_lpo --exclude-no-sfx _l"
233 _lpo="$_lpo --quiet --object-limit $var_redelta_threshold objects/pack"
234 while
235 _cnt="$(list_packs --count $_lpo)" || :
236 test "${_cnt:-0}" -ge $_minsmallpacks
238 [ -n "$_didprogress" ] || {
239 progress "~ [$proj] combining small loose packs into a single larger pack"
240 _didprogress=1
242 _newp="$(list_packs $_lpo | combine_packs --names --weak-naming $noreusedeltaopt)"
243 # We need to identify these packs later so we don't combine_packs them
244 for _objpack in $_newp; do
245 rename_pack "objects/pack/pack-$_objpack" "objects/pack/pack-${_objpack}_l" || :
246 done
247 v_cnt _newc $_newp
248 # be paranoid and exit the loop if we haven't reduced the number of packs
249 [ $_newc -lt $_cnt ] || break
250 _minsmallpacks=2
251 done
252 return 0
255 # Unfortunately, some fetch strategies (e.g. git-svn and non-smart HTTP) lack
256 # the ability to store newly fetched objects in a pack.
257 # However, the fetch code conveniently sets .needspack just before it fetches
258 # so that it's easy to find all the loose objects that have been fetched and
259 # combine them into a pack. The --no-reuse-delta option is meaningless here
260 # since everything to be packed is a loose object and therefore not a delta so
261 # deltification will always take place.
262 make_needs_pack() {
263 [ -f .needspack ] || return 0
264 rm -f .needspackgc
265 mv -f .needspack .needspackgc
266 progress "~ [$proj] combining fetched loose objects into a pack"
267 _newp="$(find -L objects/$octet -maxdepth 1 -type f -newer .needspackgc -name "$octet19*" -print 2>/dev/null |
268 LC_ALL=C awk -F / '{print $2 $3}' |
269 run_combine_packs --objects --names $packopts --incremental --all-progress-implied $quiet --non-empty)" || {
270 # We used to fail gc here.
271 # Now, however, we just ignore the failure because we have
272 # another mechanism to handle loose objects and it's possible
273 # that the fetcher somehow brought in unconnected objects which
274 # would cause the above combine-packs to fail.
275 # By ignoring the failure and just removing the .needspack file
276 # the loose objects will be treated as "ordinary" loose objects
277 # and packed using the "--weak-naming" option which can handle
278 # broken connectivity.
279 # That's a better solution than just failing here or leaving
280 # .needspack behind to potentially continue to fail again and
281 # again.
282 _newp=
284 if [ -n "$_newp" ]; then
285 # remove the now-redundant loose objects -- this is always safe
286 # even during a concurrent push because a reprepare_packed_git
287 # will be triggered if an object that should be there is not
288 # found thereby finding it in the new pack instead
289 git prune-packed $quiet
291 rm -f .needspackgc
294 # HEADSHA="$(pack_is_complete /full/path/to/some.pack /full/path/to/packed-refs "$(cat HEAD)")"
295 pack_is_complete() {
296 # Must have a matching .idx file and a non-empty packed-refs file
297 [ -s "${1%.pack}.idx" ] || return 1
298 [ -s "$2" ] || return 1
299 _headsha=
300 case "$3" in
301 $octet20*)
302 _headsha="$3"
304 "ref: refs/"?*|"ref:refs/"?*|"refs/"?*)
305 _headmatch="${3#ref:}"
306 _headmatch="${_headmatch# }"
307 _headmatchpat="$(echo "$_headmatch" | LC_ALL=C sed -e 's/\([.$]\)/\\\1/g')"
308 _headsha="$(LC_ALL=C grep -e "^$octet20$hexdig* $_headmatchpat\$" <"$2" |
309 LC_ALL=C cut -d ' ' -f 1)"
310 case "$_headsha" in $octet20*) :;; *)
311 return 1
312 esac
315 # bad HEAD
316 return 1
317 esac
318 rm -rf pack_is_complete_test
319 mkdir pack_is_complete_test
320 mkdir pack_is_complete_test/refs
321 mkdir pack_is_complete_test/objects
322 mkdir pack_is_complete_test/objects/pack
323 echo "$_headsha" >pack_is_complete_test/HEAD
324 ln -s "$1" pack_is_complete_test/objects/pack/
325 ln -s "${1%.pack}.idx" pack_is_complete_test/objects/pack/
326 ln -s "$2" pack_is_complete_test/packed-refs
327 _count="$(git --git-dir=pack_is_complete_test rev-list --count --all 2>/dev/null)" || :
328 rm -rf pack_is_complete_test
329 [ -n "$_count" ] || return 1
330 [ "$_count" -gt 0 ] 2>/dev/null || return 1
331 echo "$_headsha"
334 # write the hexadecimal sha256 hash of stdin plus a trailing newline to stdout
335 sig_hash_stdin() {
336 "$cfg_basedir/bin/ltsha256"
339 # Compute a "signature" for the refs in the specified (default .) repository.
340 # Instead of passing --head to show-ref, the actual contents of HEAD are used
341 # to capture changes in HEAD's symbolic-ref value that would otherwise be missed.
342 # $1 => variable name to store result hash in
343 # $2 => --git-dir to use, defaults to "."
344 v_compute_refs_sighash() {
345 eval "$1="'"$({ cat "${2:-.}/HEAD"; git --git-dir="${2:-.}" show-ref; } |
346 sig_hash_stdin)"'
349 # On return a "$lockf" will have been created that must be removed when gc is done
350 lock_gc() {
351 v_lock_gc _lockresult || {
352 echo >&2 "[$proj] $_lockresult"
353 exit 1
355 lockf="$_lockresult"
358 # Create a repack subdirectory such that running repack in it will pack the
359 # same things that a pack in the normal directory would except that the pack
360 # is guaranteed to be generated in an optimized order by adding a suitable
361 # synthesized ref in the refs/tags namespace (yes, pack-objects.c really does
362 # behave differently depending on the contents of the refs/tags namespace).
363 # Before calling this, pack-refs --all MUST be performed or the wrong pack
364 # will end up being made.
366 # If a ref deletion is pushed after making the repack subdir but before the
367 # the actual repack, the discarded objects will be packed -- no big deal,
368 # they'll get discarded the next time gc runs.
370 # If a fast-forward ref update is pushed after making the repack subdir but
371 # before the actual repack, it will be picked up and the new objects packed
372 # (subject to the normal git repack race about picking such updates up).
374 # If a non-fast-forward ref update is pushed after making the repack subdir but
375 # before the actual repack, it will be picked up like a fast-forward update but
376 # the discarded objects will be included like a ref deletion (until the next
377 # scheduled gc takes place).
379 # We retain a copy of the original packed-refs file as repack/packed-refs.orig
380 # If ref deletions come in while we're repacking, the original packed-refs
381 # file will be modified, but we'll still pack the deleted ref(s).
382 # If the packed-refs.orig file is used to create the bundle header we avoid
383 # a situation where the bundle contains a ref state that never actually
384 # existed in reality (for example a new branch is pushed and then an old
385 # branch deleted afterwards -- the deletion would show up in the bundle
386 # because it will cause the original packed-refs file to be re-written, but
387 # the new branch creation will not unless we do another pack-refs which might
388 # lead to having in incomplete bundle). Therefore we want to keep a copy of
389 # the original packed-refs file around. We do the same thing for HEAD.
391 # It's possible that the "objects" subdirectory is a symbolic link.
392 # Git does support this. However, during the repacking process, new packs
393 # will be created in repack/alt/pack and then moved into objects/pack.
394 # In order for this to work seemlessly, they must both be on the same
395 # filesystem. But when objects (or even objects/pack) is a symbolic link they
396 # might not be. For this reason a "repack" subdirectory is created under
397 # objects/pack and the repack/alt/pack directory symbolicly linked to it.
399 # Git allows not just HEAD to be a symbolic-ref, but any ref anywhere in the
400 # refs namespace. We are concerned about ref name collisions and getting the
401 # right tag set to get an optimal pack. We can safely duplicate the ref space
402 # under refs/heads, refs/notes and refs/remotes without any risk of unwanted
403 # collisions and this will likely make over 99%+ of all symbolic refs found
404 # in the wild work properly. Girocco itself never creates any symbolic refs
405 # inside the refs namespace; this is a nod to simultaneously using a Girocco
406 # repository for other purposes.
407 make_repack_dir() {
408 ! [ -d repack ] || rm -rf repack
409 ! [ -d repack ] || { echo >&2 "[$proj] cannot remove repack subdirectory"; exit 1; }
410 [ -d objects/pack ] || mkdir -p objects/pack
411 ! [ -d objects/pack/repack ] || rm -rf objects/pack/repack
412 ! [ -d objects/pack/repack ] || { echo >&2 "[$proj] cannot remove objects/pack/repack subdirectory"; exit 1; }
413 mkdir repack repack/refs repack/alt objects/pack/repack
414 [ -d info ] || mkdir info
415 ln -s ../config repack/config
416 ln -s ../info repack/info
417 ln -s ../objects repack/objects
418 ln -s "$PWD/objects/pack/repack" repack/alt/pack
419 ! [ -d logs ] || ln -s ../logs repack/logs
420 ! [ -d worktrees ] || ln -s ../worktrees repack/worktrees
421 _lines=$(( $(LC_ALL=C wc -l <packed-refs) ))
422 cat HEAD >repack/HEAD.orig
423 cat packed-refs >repack/packed-refs.orig
424 ln -s packed-refs.orig repack/packed-refs
425 cp repack/HEAD.orig repack/HEAD
426 v_compute_refs_sighash _rsig repack
427 rm repack/packed-refs repack/HEAD
428 ln -s ../../refs repack/refs/refs
429 echo "$_rsig" >repack/packed-refs.sighash
430 >repack/packed-refs.extra
431 _xtralines=0
432 if [ $(LC_ALL=C wc -l <repack/packed-refs.orig) -ne "$_lines" ]; then
433 echo >&2 "[$proj] error: make_repack_dir failed original packed-refs line count sanity check"
434 exit 1
436 if [ "${cfg_fetch_stash_refs:-0}" = "0" ]; then
437 # migrate any refs/stash or refs/tgstash lines to repack/packed-refs.extra
438 <repack/packed-refs.orig LC_ALL=C awk -v xtra="repack/packed-refs.extra" '
439 BEGIN { peeling = 0 }
440 NR == 1 && /^#/ { print; next; }
441 peeling && /^\^/ { print >>xtra; next; }
442 /^[0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f][0-9A-Fa-f]+ refs\/(stash|tgstash)(\/|$)/ {
443 peeling = 1
444 print >>xtra
445 next
447 { peeling = 0; print; }
448 ' >repack/packed-refs.new
449 _xtralines="$(( $(LC_ALL=C wc -l <repack/packed-refs.extra) + 0 ))"
450 _newlines="$(( $(LC_ALL=C wc -l <repack/packed-refs.new) + 0 ))"
451 if [ "$(( $_newlines + $_xtralines ))" -ne "$_lines" ]; then
452 echo >&2 "[$proj] error: make_repack_dir failed packed-refs.extra line count sanity check"
453 exit 1
455 mv -f repack/packed-refs.new repack/packed-refs.orig
456 _lines="$_newlines"
458 # Note: Git v1.5.0 introduced the "# pack-refs with:" header line for the packed-refs file
459 sed '/^# pack-refs/d; s, refs/, refs/!/,' <repack/packed-refs.orig >repack/packed-refs
460 nohead=
461 headref="$(git rev-parse --verify --quiet HEAD)" || :
462 if [ -n "$headref" ]; then
463 echo "$headref refs/!=/HEAD" >>repack/packed-refs
464 echo "$headref refs/heads/!" >>repack/packed-refs
465 nohead='\, refs/heads/!$,d; '
466 _lines=$(( $_lines + 2 ))
468 if [ $(( $(LC_ALL=C wc -l <repack/packed-refs) + 1 )) -ne "$_lines" ]; then
469 echo >&2 "[$proj] error: make_repack_dir failed packed-refs initial line count sanity check"
470 exit 1
472 sed -n "$nohead"'\, refs/heads/,p; \, refs/notes/,p; \, refs/remotes/,p' <repack/packed-refs.orig >>repack/packed-refs
473 _newlines="$(( $(LC_ALL=C wc -l <repack/packed-refs) ))"
474 if [ $(( $_newlines + 1 )) -lt "$_lines" ]; then
475 echo >&2 "[$proj] error: make_repack_dir failed packed-refs extra line count sanity check"
476 exit 1
478 _lines="$_newlines"
479 optref="$(git rev-list -n 1 --all 2>/dev/null)" || :
480 if [ -n "$optref" ]; then
481 echo "$optref refs/tags/!" >>repack/packed-refs
482 _lines=$(( $_lines + 1 ))
483 echo "$optref" >repack/HEAD
484 else
485 cat HEAD >repack/HEAD
487 if [ $(LC_ALL=C wc -l <repack/packed-refs) -ne "$_lines" ]; then
488 echo >&2 "[$proj] error: make_repack_dir failed packed-refs line count sanity check"
489 exit 1
493 # Remove any crud that's been left behind by interrupted operations
494 # that did not clean up after themselves
495 remove_crud() {
496 # Remove any existing FETCH_HEAD
497 # There can only be a FETCH_HEAD if we've been fetching, not if we've been
498 # receiving pushes (those never create a FETCH_HEAD).
499 # And if we're fetching because we're a mirror, we know we're not fetching right
500 # now since jobd.pl never runs a project's fetch simultaneously with its gc.
501 # Therefore any existing FETCH_HEAD is junk. And it may be many megabytes if
502 # there were a lot of refs.
503 rm -f FETCH_HEAD
505 # Remove any stale ref locks
506 clear_stale_ref_locks
508 # remove any existing pack_is_complete_test or repack subdirectories
509 # If either exists when this function is called it's crud
510 rm -rf pack_is_complete_test repack objects/pack/repack
512 # Remove any stale pack remnants that are more than an hour old.
513 # Stale pack fragments are defined as any pack-<sha1>.ext where .ext is NOT
514 # .pack AND the corresponding .pack DOES NOT exist. A bunch of stale
515 # pack-<sha1>.idx files without their corresponding .pack files are worthless
516 # and just waste space. Normally there shouldn't be any remnants but actually
517 # this can happen when things are interrupted at just the wrong time.
518 # Note that the objects/pack directory is created by git init and should
519 # always exist.
520 find -L objects/pack -maxdepth 1 -type f -mmin +60 -name "pack-$octet20*.?*" -print |
521 LC_ALL=C sed -e 's/^objects\/pack\/pack-//; s/\..*$//' | LC_ALL=C sort -u |
522 while read packsha; do
523 ! [ -e "objects/pack/pack-$packsha.pack" ] || continue
524 rm -f "objects/pack/pack-$packsha".?*
525 done
527 # Remove any stale tmp reflogs files that are more than one hour old.
528 # Since they are created only while the pre-receive hook is running and
529 # all it does is process a bunch of refs passed to it on standard input
530 # it's inconceivable that it would ever take as much as an hour to run.
531 if [ -d reflogs ]; then
532 find -L reflogs -maxdepth 1 -type f -mmin +60 -name "tmp_*" -exec rm -f '{}' + || :
535 # Remove any stale object tmp_obj_* files that are more than 3 hours old.
536 # Really these files should only exist very briefly so there shouldn't be any
537 # but things happen that can end up leaving them behind.
538 find -L objects/$octet -maxdepth 1 -type f -mmin +180 -name "tmp_obj_?*" -exec rm -f '{}' + 2>/dev/null || :
540 # Remove any stale pack .keep files that are more than 12 hours old.
541 # We don't do anything to create any permanent pack .keep files, so they must
542 # be remnants from some failed push or something. Removing the .keep will
543 # allow the pack to be properly repacked.
544 find -L objects/pack -maxdepth 1 -type f -mmin +720 -name "pack-$octet20*.keep" -exec rm -f '{}' + || :
546 # Remove any stale tmp_pack_*, tmp_idx_*, tmp_bitmap_*, packtmp-* or .tmp-*-pack* files
547 # that are more than 12 hours old.
548 find -L objects/pack -maxdepth 1 -type f -mmin +720 \( \
549 -name "tmp_pack_?*" -o -name "tmp_idx_?*" -o -name "tmp_bitmap_?*" -o \
550 -name "packtmp-?*" -o -name ".tmp-?*-pack*" \
551 \) -exec rm -f '{}' + || :
553 # Remove any stale incoming-* object quarantine directories that are
554 # more than 12 hours old. These are new with Git >= 2.11.0.
555 find -L objects -maxdepth 1 -type d -name 'incoming-?*' -mmin +720 \
556 -exec rm -rf '{}' + || :
558 # Remove any stale shallow_* files that are more than 12 hours old.
559 # These can be left behind by Git >= 1.8.4.2 and < 2.0.0 when a client
560 # requests a shallow clone. Also discard stale .refs-temp* and
561 # .refs-new* files at the same time.
562 find -L . -maxdepth 1 -type f -mmin +720 \( \
563 -name "shallow_?*" -o -name ".refs-temp*" -o -name ".refs-new*" \
564 \) -exec rm -f '{}' + || :
566 # Remove any stale cmbnpcks-* dirs that are more than 12 hours old.
567 # These can be left behind by abnormal exits (e.g. power failure).
568 find -L . -maxdepth 1 -type d -mmin +720 -name "cmbnpcks-?*" \
569 -exec rm -rf '{}' + || :
571 # Remove any stale *.temp files in the objects area that are more than 12 hours old.
572 # This can be stale sha1.temp, or stale *.pack.temp so we kill all stale *.temp.
573 find -L objects -type f -mmin +720 -name "*.temp" -exec rm -f '{}' + || :
575 # Remove any stale *.lock files in the htmlcache area that might have been left
576 # behind after an abnormal exit during an attempt to update a cached file and
577 # are more than 1 hour old.
578 ! [ -d htmlcache ] || find -L htmlcache -type f -mmin +60 -name "*.lock" -exec rm -f '{}' + || :
580 # Remove any stale git-svn temp files that are more than 12 hours old.
581 # The git-svn process creates temp files with random 10 character names
582 # in the root of $GIT_DIR. Unfortunately they do not have a recognizable
583 # prefix, so we just have to kill any files with a 10-character name. We
584 # do this only for git-svn mirrors. All characters are chosen from
585 # [A-Za-z0-9_] so we can at least check that and fortunately the only
586 # collision is 'FETCH_HEAD' but that shouldn't matter.
587 # There may also be temp files with a Git_ prefix as well.
588 if [ -n "$svn_mirror" ]; then
589 _randchar='[A-Za-z0-9_]'
590 _randchar2="$_randchar$_randchar"
591 _randchar4="$_randchar2$_randchar2"
592 _randchar10="$_randchar4$_randchar4$_randchar2"
593 find -L . -maxdepth 1 -type f -mmin +720 -name "$_randchar10" -exec rm -f '{}' + || :
594 find -L . -maxdepth 1 -type f -mmin +720 -name "Git_*" -exec rm -f '{}' + || :
597 # Remove any stale fast_import_crash_<pid> files that are more than 3 days old.
598 if [ -n "$gfi_mirror" ]; then
599 find -L . -maxdepth 1 -type f -mmin +4320 -name "fast_import_crash_?*" -exec rm -f '{}' + || :
602 # Remove any stale core or *.core or core.* files that are more than 3 days old.
603 find -L . -maxdepth 1 -type f -mmin +4320 \( -name "core" -o -name "*.core" -o -name "core.*" \) \
604 -exec rm -f '{}' + || :
608 ## Garbage Collection Types
610 ## There are two kinds of possible garbage collection (gc) operations:
612 ## 1. A normal, full gc
613 ## 2. A "mini" gc
615 ## If the full garbage collection interval has expired (or gc has never been
616 ## run), then a normal, full gc will take place. Otherwise, a "mini" gc will
617 ## take place if the file .needsgc exists.
619 ## A "mini" gc is similar to "git gc --auto" in that it may not end up actually
620 ## doing anything unless the right conditions are present so it's not a burden
621 ## to run it often. If the file .needsgc exists, a "mini" gc will occur at
622 ## the next opportunity.
624 ## See the docs/technical/gc.txt and docs/technical/gc-mini.txt files for more
625 ## of the gory details of how garbage collection is performed.
627 ## Note, however, that the .nogc file suppresses ALL gc activity (normal or mini).
630 proj="${1%.git}"
631 shift
632 cd "$cfg_reporoot/$proj.git"
633 [ -d objects/pack ] || { rm -f gfi-packs; mkdir -p objects/pack; }
634 mirror_url="$(get_mirror_url)" || :
635 svn_mirror=
636 ! is_svn_mirror_url "$mirror_url" || svn_mirror=1
637 gfi_mirror=
638 if [ -f gfi-packs ] && [ -s gfi-packs ] && is_gfi_mirror_url "$mirror_url"; then
639 gfi_mirror=1
642 # If git config --bool --get girocco.redelta is explicitly false then automatic
643 # redelta when there are less than $var_redelta_threshold objects will be suppressed.
644 # On the other hand, if git config --get girocco.redelta is "always" then, on a full
645 # gc only, for the final repack, deltas will always be recomputed.
646 # This can be set on a per-project basis to avoid unusual pathological gc behavior.
647 # Setting this will hurt efficiency of the affected repository.
648 # Note that fast-import packs ALWAYS get new deltas regardless of this setting.
649 noreusedeltaopt="--no-reuse-delta"
650 [ "$(git config --bool --get girocco.redelta 2>/dev/null || :)" != "false" ] || noreusedeltaopt=
651 alwaysredelta=
652 [ "$(git config --get girocco.redelta 2>/dev/null || :)" != "always" ] || alwaysredelta=1
654 # Extract any -f or -F or --no-reuse-object or --no-reuse-delta options
655 # to be compatible with the old and new gc.sh versions and avoid ugly argument
656 # duplication in process lists at the same time
657 # Any options found will override the "girocco.redelta" setting
658 recompress=
659 idx=$#
660 while [ $idx -gt 0 ]; do
661 idx=$(( $idx - 1 ))
662 opt="$1"
663 shift
664 case "$opt" in
665 -f|--no-reuse-delta)
666 alwaysredelta=1
667 continue
669 -F|--no-reuse-object)
670 alwaysredelta=1
671 recompress=1
672 continue
674 -?*)
677 printf >&2 '%s\n' "bad non-option argument: $opt"
678 echo >&2 "(Did you perhaps intend to use a --xxx=yyy form?)"
679 exit 1
680 esac
681 [ -z "$opt" ] || set -- "$@" "$opt"
682 done
683 if [ -n "$alwaysredelta" ]; then
684 noreusedeltaopt="--no-reuse-delta"
685 [ -z "$recompress" ] || noreusedeltaopt="--no-reuse-object"
688 trap 'e=$?; rm -f .gc_in_progress; if [ $e != 0 ]; then echo "gc failed dir: $PWD" >&2; fi' EXIT
689 trap 'exit 130' INT
690 trap 'exit 143' TERM
692 # date -R is linux-only, POSIX equivalent is '+%a, %d %b %Y %T %z'
693 datefmt='+%a, %d %b %Y %T %z'
695 isminigc=
696 if [ "${force_gc:-0}" = "0" ] && check_interval lastgc $cfg_min_gc_interval; then
697 if [ -e .needsgc ]; then
698 isminigc=1
699 else
700 progress "= [$proj] garbage check skip (last at $(config_get lastgc))"
701 exit 0
704 if [ -e .nogc ]; then
705 progress "x [$proj] garbage check disabled"
706 exit 0
708 if ! [ -e .nofetch ] && [ -e .clone_in_progress ] && ! [ -e .clone_failed ]; then
709 progress "x [$proj] garbage check disabled (clone in progress)"
710 exit 0
712 if [ -z "$isminigc" ] && [ -e .delaygc ] && [ -e .needsgc ]; then
713 # Eligible for a full gc but .delaygc is set so it would be skipped
714 # However .needsgc is also set so transform it into a mini instead
715 isminigc=1
716 progress "~ [$proj] garbage check delayed but checking mini because .needsgc"
719 if [ -n "$isminigc" ]; then
720 # Perform a "mini" gc
721 # Note that .delaygc is ignored here as that's only intended for full gc
722 lock_gc
723 rm -f .allowgc .needsgc
724 rm -f objects/pack/pack-*_[rful].keep
725 remove_crud
726 coalesce_reflogs
727 prune_reflogs
728 compact_reflogs
729 maintain_auto_gc_hack
730 generate_auto_gc_update
731 miniactive=
732 if [ -f .needspack ]; then
733 miniactive=1
734 progress "+ [$proj] mini garbage check ($(date))"
735 make_needs_pack
737 if [ -z "$cfg_delay_gfi_redelta" ] && [ -n "$gfi_mirror" ]; then
738 # $Girocco::Config::delay_gfi_redelta is false, force redeltification now
739 if [ -z "$miniactive" ]; then
740 miniactive=1
741 progress "+ [$proj] mini garbage check ($(date))"
743 repack_gfi_packs
745 if lotsa_loose_objects; then
746 if [ -z "$miniactive" ]; then
747 miniactive=1
748 progress "+ [$proj] mini garbage check ($(date))"
750 pack_loose_objects
752 # If there aren't at least 10 non-keep, non-bitmap, non-bndl packs then
753 # don't actually process them yet
754 lpo="--exclude-no-idx --exclude-keep --exclude-bitmap --exclude-bndl --quiet"
755 packcnt="$(list_packs --count $lpo objects/pack)" || :
756 if [ "${packcnt:-0}" -ge 10 ]; then
757 if [ -z "$miniactive" ]; then
758 miniactive=1
759 progress "+ [$proj] mini garbage check ($(date))"
761 # if we have at least 10 packs go ahead and pack all refs now too
762 git pack-refs --all --prune
763 if [ -n "$gfi_mirror" ]; then
764 repack_gfi_packs
765 packcnt="$(list_packs --count $lpo objects/pack)" || :
767 # if repack_gfi_packs dropped the pack count to < 10 don't combine
768 if [ "${packcnt:-0}" -ge 10 ]; then
769 combine_small_packs
770 combine_small_loose_packs
771 packcnt="$(list_packs --count $lpo objects/pack)" || :
773 # if we still have more than 10 packs trigger a full gc
774 if [ "${packcnt:-0}" -ge 10 ]; then
775 # We shouldn't be in a .delaygc state at this point, but if
776 # we are then nuke it because we really need a full gc now
777 rm -f .delaygc
778 git config --unset gitweb.lastgc || :
779 rm -f "$lockf"
780 git update-server-info # just in case
781 progress "- [$proj] mini garbage check triggering full gc too many packs ($(date))"
782 exit 0
785 rm -f "$lockf"
786 if [ -n "$miniactive" ]; then
787 git update-server-info
788 progress "- [$proj] mini garbage check ($(date))"
789 else
790 progress "= [$proj] mini garbage check nothing but crud removal to do ($(date))"
792 exit 0
795 # Avoid unnecessary garbage collections:
796 # 1. If lastreceive is set and is older than lastgc
797 # -AND-
798 # 2. We are not a fork (is_empty_alternates_file) -OR- lastparentgc is older than lastgc
800 # If lastgc is NOT set or lastreceive is NOT set we MUST run gc
801 # If we are a fork and lastparentgc is NOT set we MUST run gc
803 # If the repo is dirty after removing any crud we MUST run gc
805 gcstart="$(date "$datefmt")"
806 skipgc=
807 isfork=
808 is_empty_alternates_file objects/info/alternates || isfork=1
809 lastparentgcsecs=
810 [ -z "$isfork" ] || lastparentgcsecs="$(config_get_date_seconds lastparentgc)" || :
811 lastreceivesecs=
812 if lastreceivesecs="$(config_get_date_seconds lastreceive)" &&
813 [ "${force_gc:-0}" = "0" ] &&
814 lastgcsecs="$(config_get_date_seconds lastgc)" &&
815 [ $lastreceivesecs -lt $lastgcsecs ]; then
816 # We've run gc since we last received, so maybe we can skip,
817 # check if not fork or fork and lastparentgc < lastgc
818 if [ -n "$isfork" ]; then
819 if [ -n "$lastparentgcsecs" ] &&
820 [ $lastparentgcsecs -lt $lastgcsecs ]; then
821 # We've run gc since our parent ran gc so we can skip
822 skipgc=1
824 else
825 # We don't have any alternates (we're not a forK) so we can skip
826 skipgc=1
830 # Now check the simple signatures if $skipgc and decline to skip if they do not match
832 if [ -n "$skipgc" ]; then
833 # while we cannot actually compute the current "repack" "signature"
834 # hash yet, if there is no previous sig => must run gc
835 rpksig="$(config_get girocco.gcsig.repack)" || :
836 [ -n "$rpksig" ] || skipgc=
838 if [ -n "$skipgc" ]; then
839 # make sure the "refs" "signature" hash exists before doing anything expensive
840 # no previous "refs" "signagure" => must run gc
841 rhash="$(config_get girocco.gcsig.refs)" || :
842 [ -n "$rhash" ] || skipgc=
844 if [ -n "$skipgc" ]; then
845 # check the "packs" "signature" first, no previous sig => must run gc
846 phash="$(config_get girocco.gcsig.packs)" || :
847 [ -n "$phash" ] || skipgc=
848 if [ -n "$skipgc" ]; then
849 # a previous packs sig is available, check for a match
850 _chksig="$(list_packs -C objects/pack --exclude-no-idx --quiet . |
851 LC_ALL=C sort | sig_hash_stdin)" || :
852 [ "$phash" = "$_chksig" ] || skipgc=
855 if [ -n "$skipgc" ]; then
856 # check the refs signature second
857 # a previous refs sig is available, check for a match
858 v_compute_refs_sighash _chksig
859 [ "$rhash" = "$_chksig" ] || skipgc=
862 # Prevent any other simultaneous gc operations
863 lock_gc
865 # At this point, if .allowgc or .gc_failed exists, it's now crud to be removed
866 rm -f .allowgc .gc_failed
868 # Always get rid of crud
869 remove_crud
871 # Ideally we would do this in post-receive, but that would mean duplicating the
872 # logic so it's available in the chroot jail and that's highly undesirable
873 # Instead, since the first gc will be triggered immediately following the first
874 # push, we do the check here as it's quick and harmless if HEAD is already valid
875 check_and_set_head || :
877 # Always perform reflogs maintenance
878 coalesce_reflogs
879 prune_reflogs
880 compact_reflogs
882 # Always maintain auto gc hack
883 maintain_auto_gc_hack
884 generate_auto_gc_update
886 # Run 'git svn gc' now for svn mirrors
887 if [ -n "$svn_mirror" ]; then
888 git svn gc || :
891 # Skip the actual gc if .delaygc is set
892 if [ -e .delaygc ]; then
893 progress "x [$proj] garbage check delayed (except for crud removal)"
894 rm -f "$lockf"
895 exit 0
898 # Do not skip gc if the repo is dirty
899 [ -z "$skipgc" ] || ! is_dirty || skipgc=
901 # It's safe to do this part before checking the "repack" "signature" hash because
902 # this section won't do anything unless lastparentgc and/or lastreceive is unset
903 # in which case we never skip gc anyway
904 bumptime=
905 if [ -n "$isfork" ] && [ -z "$lastparentgcsecs" ]; then
906 # set lastparentgc and then update gcstart to be at least 1 second later
907 config_set lastparentgc "$gcstart"
908 bumptime=1
910 if [ -z "$lastreceivesecs" ]; then
911 # set lastreceive and then update gcstart to be at least 1 second later
912 config_set lastreceive "$gcstart"
913 bumptime=1
915 if [ -n "$bumptime" ]; then
916 sleep 1
917 gcstart="$(date "$datefmt")"
921 ## Safe Pruning In Forks
923 ## We are about to perform garbage collection. We do NOT use the "git gc" or
924 ## the "git repack" commands directly as they do not provide enough control over
925 ## the fine details. However, we DO maintain a "gc.pid" file during our garbage
926 ## collection so that a simultaneous "git gc" by an administrator will be
927 ## blocked (and similarly we refuse to start garbage collection if we cannot
928 ## create the "gc.pid" file).
930 ## When we say "gc" in the below description we are referring to our "gc.sh"
931 ## script, NOT the "git gc" command.
933 ## If the project we are running garbage collection (gc) on has any forks we
934 ## must be careful not to remove any objects that while no longer referenced by
935 ## this project (the parent) are still referenced by one or more forks (the
936 ## children) otherwise the children will become corrupt and we can't abide
937 ## corrupt children.
939 ## One way to accomplish this is to simply hard-link all currently existing
940 ## loose objects and packs in the parent into all the children that refer to the
941 ## parent (via a line in their objects/info/alternates file) before beginning
942 ## the gc operation and then relying on a subsequent gc in the child to clean up
943 ## any excess objects/packs. We used to use this strategy but it's very
944 ## inefficient because:
946 ## 1. The disk space used by the old pack(s)/object(s) will not be reclaimed
947 ## until all children (and their children, if any) run gc by which time
948 ## it's quite possible the topmost parent will have run gc again and
949 ## hard-linked yet another old pack down to its children (not to mention
950 ## loose objects).
952 ## 2. When using the "-A" option with "git repack", any new objects in the
953 ## parent that are not referenced by children will continually get
954 ## exploded out of the hard-linked pack in the children whenever the
955 ## children run gc.
957 ## 3. To avoid suboptimal and/or unnecessarily many packs being hard-linked
958 ## into child forks, we must run the "mini" gc maintenance before we
959 ## perform the hard-linking into the children which provides yet another
960 ## source of inefficiency.
962 ## While we were still using the "-A" option to "git repack" (that was not
963 ## always the case) to guarantee we can access old ref values for long enough
964 ## to send out a meaningful mail.sh notification, another, more efficient,
965 ## option became available to prevent corruption of child forks that continue
966 ## to refer to objects that are no longer reachable from any ref in the parent.
968 ## The only things that need be copied (or hard-linked) into the child fork(s)
969 ## are those objects that have become unreachable from any ref in the parent.
971 ## When we were using the "git repack -A -d" + "git prune --expire=1.day.ago"
972 ## technique, the only objects that could ever be removed were loose objects
973 ## that "git prune" determined were expired. In that case, loose objects were
974 ## all that need be hard-linked down to child forks in order to avoid
975 ## corruption of any child fork(s).
977 ## The "git repack -A -d" + "git prune --expire=1.day.ago" + hard-linking loose
978 ## objects to child forks technique remains fundamentally sound from the
979 ## perspective of supporting simultaneous gc and push and keeping newly
980 ## unreachable objects around long enough to be sure we can send out meaningful
981 ## ref change notifications and never corrupting any child forks and never
982 ## persisting the lifetime of large old packs containing mostly duplicate or
983 ## unreachable objects as gc percolates through a project's entire fork tree.
985 ## However, that technique suffers from one potential prodigious pitfall.
987 ## Unreachable objects come flying out of their packs to splatter all over the
988 ## objects subdirectories possibly creating a huge, inefficient mess.
990 ## Often this is not an issue. Even with a lot of rebasing going on, usually
991 ## the only objects that will splatter are some commits, trees and the odd blob
992 ## here and there. Not enough to be overly concerned about.
994 ## However, for the reppository that frequently experiences a lot of non-fast-
995 ## forward updates and/or outright ref deletion, the number of objects suddenly
996 ## popping out of their packs at "git repack -A -d" time can be overwhelming.
998 ## To avoid this issue we now use a four phase pack creation strategy.
999 ## This will result in creation of up to four packs (instead of at most one).
1001 ## I. A complete pack (with bitmaps if appropriate) gets created including
1002 ## only "reachable" objects from all refs/... refs plus HEAD. This will
1003 ## also serve as the virtual bundle for the repository.
1005 ## II. A pack of recently-became-unreachable objects and friends is created.
1006 ## (The "friends" are ref logs, linked working tree HEADs and indicies.)
1007 ## Because both the pre-receive and update.sh script record all ref
1008 ## changes we can easily choose the cut off point for "recently".
1009 ## It is only the fact we maintain those logs in the reflogs subdirectory
1010 ## that allows this step to be possible.
1012 ## III. If the repository has any forks with a non-zero length alternates file,
1013 ## yet another pack of "--keep-unreachable" objects is generated that will
1014 ## not actually be kept in the parent, but hard-linked into all the forks.
1016 ## IV. Finally, after running "git prune-packed", any remaining loose objects
1017 ## are migrated into a pack of their own.
1019 ## We then remove any non-.keep packs that existed before we started the
1020 ## process being careful to keep any same-pack pushes for the "Push Pack Redux"
1021 ## race condition (see docs/technical/gc.txt).
1023 ## By using "git pack-objects" directly we are able to accomplish this with
1024 ## very little additional effort.
1026 ## The packs produced by (III) are treated almost like ".keep" packs by child
1027 ## forks in that the objects in them are never repacked into any other
1028 ## "--keep-unreachable" packs (but they can migrate into phase I or II packs)
1029 ## and those phase III packs are then hard-linked into any grandchild forks.
1031 ## This avoids the space explosion that could occur if each fork level ended
1032 ## up duplicating the "--keep-unreachable" pack space by repacking those
1033 ## objects (essentially breaking the hard-link to the single copy of those
1034 ## objects).
1036 ## While it is true that each level of forks could potentially add yet another
1037 ## phase III pack to be hard-linked down to its children, such packs will only
1038 ## include unreachable objects not already in any phase III packs that were
1039 ## received from the parent.
1041 ## The space for the phase III packs will not be reclaimed until the gc
1042 ## finishes percolating through the entire "fork tree" of a project.
1044 ## This is not much different than the "git repack -A -d" situation where
1045 ## all the loose objects are hard-linked down into child forks. In that
1046 ## case forks that actually need any of those objects could gradually reduce
1047 ## the number of objects hard-linked into deeper fork levels.
1049 ## The difference with a phase III "--keep-unreachable" pack is that there
1050 ## cannot be any gradual reduction like that since it would require repacking
1051 ## the pack and breaking the hard-link thereby increasing storage space. The
1052 ## storage will instead always be reclaimed all at once when all of the
1053 ## projects in the "fork tree" complete their gc.
1055 ## However, the belief is that the huge space win by having all the
1056 ## unreachable objects packed up together far eclipses (when many objects are
1057 ## involved, the single-pack version can end up using 1/20th or less of the
1058 ## disk space compared to having them all as loose objects) any brief minor
1059 ## space savings that might occur under the "git repack -A -d" loose object
1060 ## system prior to the gc collection completing for all the projects in the
1061 ## "fork tree".
1065 ## utility functions
1068 make_packs_ugw() {
1069 find -L "$1" -maxdepth 1 -type f ! -perm -ug+w \
1070 -name "pack-$octet20*.pack" -exec chmod ug+w '{}' + || :
1071 } 2>/dev/null
1073 get_index_tree() {
1074 if [ -s "$1" ]; then
1075 GIT_INDEX_FILE="$1"
1076 export GIT_INDEX_FILE
1077 git write-tree 2>/dev/null || :
1078 unset GIT_INDEX_FILE
1082 get_detached_head() {
1083 if [ -s "$1" ] && read -r _head <"$1" 2>/dev/null; then
1084 case "$_head" in $octet20*)
1085 echo "$_head"
1086 esac
1090 # single argument must be a top-level GIT_DIR
1091 # output will be (one per line, zero or more lines) full hash
1092 # values (i.e. 40 or more hex digits) from possible detached head
1093 # "single level" refs (e.g. "FETCH_HEAD" "MERGE_HEAD" etc.) from
1094 # files in the specified directory that have a "suitable" name and
1095 # have a length >= 40 and <= 1000 where EVERY line in a file MUST
1096 # match a 40 digit (or longer) hex string or that file will be ignored.
1097 # In a nod to Git each line first has any tab and anything following truncated.
1098 # NO sorting NOR "uniq"ing NOR "--batch-check"ing is performed on the output.
1099 # Also note that "HEAD" is NOT EXCLUDED and if detached will be output!
1100 get_detached_friends() {
1101 if [ -n "$1" ] && [ -d "$1" ]; then
1102 LC_ALL=C find -H "$1" -maxdepth 1 -name '[A-Za-z]*[A-Za-z0-9]' \
1103 -type f -size +39c -size -1001c -exec awk '
1104 BEGIN {exit}
1105 function process(fn, fnt, hashes, hcnt, fl, hi) {
1106 fnt = fn; sub(/^.*\//, "", fnt)
1107 if (length(fnt) > 31 || fnt !~ /^[A-Za-z][A-Za-z0-9_-]*[A-Za-z0-9]$/) return;
1108 hcnt = 0;
1109 while (getline fl < fn) {
1110 sub(/\t.*$/, "", fl)
1111 if (length(fl) < 40 || fl !~ /^[0-9a-fA-F][0-9a-fA-F]*$/) {hcnt = 0; break;}
1112 hashes[++hcnt] = fl;
1114 close(fn)
1115 for (hi=1;hi<=hcnt;++hi) print tolower(hashes[hi]);
1117 END {for (idx=1;idx<ARGC;++idx) process(ARGV[idx])}
1118 ' '{}' '+' 2>/dev/null || :
1122 # get_worktrees_friends
1123 # single argument is a (possibly relative) path to a "worktrees" subdir
1124 # if omitted it defaults to "worktrees"
1125 # any "friends" found in there are output to stdout
1126 get_worktrees_friends() {
1127 if [ -d "${1:-worktrees}" ]; then
1128 find -L "${1:-worktrees}" -mindepth 2 -maxdepth 2 -name HEAD -type f -print |
1129 while read -r _lwth; do
1130 get_detached_head "$_lwth"
1131 get_detached_friends "${_lwth%HEAD}"
1132 get_index_tree "${_lwth%HEAD}index"
1133 done
1137 # compute_extra_reachables
1138 # create lines suitable for a packed-refs file mentioning all the
1139 # other refs we might like to keep.
1140 # the current directory MUST be set to the repository's --git-dir
1141 # the following are included:
1142 # * refs mentioned in repack/packed-refs.extra (if it exists)
1143 # * refs mentioned in reflogs/... files
1144 # * tree(s) created from index file(s)
1145 # * detached linked working tree heads
1146 # Resulting objects are tested for existence and uniqified then output
1147 # one per line under a refs/z* namespace
1148 compute_extra_reachables() {
1150 if [ -s repack/packed-refs.extra ]; then
1151 LC_ALL=C sed <repack/packed-refs.extra -n \
1152 -e 's/^\([0-9A-Fa-f][0-9A-Fa-f]*\).*$/\1/p' \
1153 -e 's/^\^\([0-9A-Fa-f][0-9A-Fa-f]*\).*$/\1/p'
1155 digits8='[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]'
1156 find -L reflogs -mindepth 1 -maxdepth 1 -type f -name "$digits8*" -exec gzip -c -d -f '{}' + |
1157 LC_ALL=C awk '{print $2; print $3}'
1158 get_detached_friends .
1159 ! [ -f index ] || get_index_tree index
1160 get_worktrees_friends
1162 is_git_dir private &&
1163 [ "$(cd objects && pwd -P)" = "$(cd private/objects && pwd -P)" ] &&
1164 [ "$(cd refs && pwd -P)" != "$(cd private/refs && pwd -P)" ]
1165 then
1166 git --git-dir=private show-ref --head --hash 2>/dev/null || :
1167 get_detached_friends private
1168 ! [ -f private/index ] || get_index_tree private/index
1169 get_worktrees_friends private/worktrees
1171 } | LC_ALL=C sort -u |
1172 git cat-file ${var_have_git_260:+--buffer} --batch-check"${var_have_git_185:+=%(objectname)}" |
1173 LC_ALL=C awk '!/missing/ {num++; print $1 " " "refs/" substr("zzzzzzzzzzzz", 1, length(num)) "/" num}'
1176 # cat_all_ref_logs
1177 # the current directory MUST be set to the repository's --git-dir
1178 # first the arguments (which must reference readable files) are cat'd if any
1179 # then the path names of all ref log files are sorted and cat'd in that order
1180 # included in output:
1181 # * the contents of the pathnames given as arguments (if any) in order
1182 # * any existing files in the logs subdirectory and any existing worktree HEAD logs
1183 # but always in sorted filename order
1184 # obviously any missing directories are silently skipped
1185 cat_all_ref_logs() {
1186 [ $# -le 0 ] || LC_ALL=C cat -- "$@"
1188 ! [ -d logs ] || find -L logs -name '.*' -prune -o -name '*.' -prune -o -type f -size +0c -print
1189 if [ -d worktrees ]; then
1190 find -L worktrees -mindepth 2 -maxdepth 2 -name HEAD -type f -print |
1191 while read -r _lwth; do
1193 [ -d "${_lwth%HEAD}logs" ] &&
1194 [ -f "${_lwth%HEAD}logs/HEAD" ]
1195 then
1196 printf '%s\n' "${_lwth%HEAD}logs/HEAD"
1198 done
1200 } | LC_ALL=C sort | LC_ALL=C sed 's/[^A-Za-z0-9._/-]/\\&/g' | xargs env LC_ALL=C cat --
1204 ## main gc logic
1207 # Everything else is more efficient if we do this first
1208 # The "--prune" option is the default since v1.5.0 but it serves as "documentation" here
1209 git pack-refs --all --prune
1210 [ -e packed-refs ] || >>packed-refs # should never happen...
1212 # We didn't used to do anything about rerere or worktrees but we're
1213 # trying to make nice with linked working trees these days :)
1214 # Maybe even non-bare repositories too, but *shush* about those ;)
1216 # If we have a worktrees subdir and are running Git >= 2.5.0, prune worktrees
1217 # By doing this first we may save some work if any worktrees are pruned
1218 # Git will remove the worktrees subdir entirely when the last worktree is pruned
1219 if [ -n "$var_have_git_250" ] && [ -d worktrees ]; then
1220 # The value "3.months.ago" is hard-coded into gc.c rather than
1221 # having the default be in worktree.c so we must provide it if
1222 # we get nothing out of the gc.worktreePruneExpire config item
1223 # Prior to Git v2.6.0 the config item was gc.pruneworktreesexpire
1224 # however we just always use the newer name no matter what Git version
1225 expiry="$(git config --get gc.worktreePruneExpire 2>/dev/null)" || :
1226 eval git worktree prune --expire '"${expiry:-3.months.ago}"' "${quiet:+>/dev/null 2>&1}" || :
1229 # If we have a logs directory or a worktrees directory expire the ref logs now
1230 # Note that Git itself does not use either --rewrite or --updateref, so neither do we
1231 ! [ -d logs ] && ! [ -d worktrees ] || eval git reflog expire --all "${quiet:+>/dev/null 2>&1}" || :
1233 # git rerere does it right and handles its own default/config'd expiration values
1234 ! [ -d rr-cache ] || eval git rerere gc "${quiet:+>/dev/null 2>&1}" || :
1236 make_repack_dir
1238 # if we are in a possible $skipgc situation, compute and check the final
1239 # signature hash and possibly exit without actually doing anything more
1240 # if we get this far and $skipgc is true then $rpksig must be non-empty
1241 if [ -n "$skipgc" ]; then
1242 # compute the current value of the "repack" "signature" hash
1243 # it wasn't possible to do this until `make_repack_dir` was run
1244 _chksig="$({
1245 cat repack/packed-refs
1246 compute_extra_reachables
1247 cat_all_ref_logs
1248 } | sig_hash_stdin)" || :
1249 [ "$rpksig" = "$_chksig" ] || skipgc=
1252 if [ -n "$skipgc" ]; then
1253 # remove no longer needed repack and objects/pack/repack dirs and contents
1254 # while not free to create them, it's cheaper to create and destroy
1255 # them than to do an actual full gc on anything but a tiny project
1256 rm -rf repack objects/pack/repack
1257 progress "= [$proj] garbage check nothing but crud removal to do ($(date))"
1258 config_set lastgc "$gcstart"
1259 rm -f "$lockf"
1260 exit 0
1263 progress "+ [$proj] garbage check ($(date))"
1265 newdeltas=
1266 [ -z "$alwaysredelta" ] || newdeltas="$noreusedeltaopt"
1267 if [ -z "$newdeltas" ] && [ -n "$gfi_mirror" ]; then
1268 if [ $(list_packs --exclude-no-idx --count objects/pack) -le \
1269 $(list_packs --exclude-no-idx --count --quiet --only gfi-packs) ]; then
1270 # Don't bother with repack_gfi_packs since everything's being repacked
1271 newdeltas="--no-reuse-delta"
1274 if [ -z "$newdeltas" ] && [ -n "$noreusedeltaopt" ] &&
1275 [ $(list_packs --all --exclude-no-idx --count-objects objects/pack) -le $var_redelta_threshold ]; then
1276 # There aren't enough objects to worry about so just redelta to get the best pack
1277 newdeltas="--no-reuse-delta"
1279 if [ -z "$newdeltas" ]; then
1280 # Since we're not going to recompute deltas overall, we need to do the
1281 # "mini" maintenance so that we can get more optimal deltas
1282 [ -z "$noreusedeltaopt" ] || make_needs_pack
1283 repack_gfi_packs
1284 force_single_pack_redelta=
1285 [ -n "$gfi_mirror" ] || [ -n "$svn_mirror" ] || force_single_pack_redelta=1
1286 [ -z "$noreusedeltaopt" ] || combine_small_packs $force_single_pack_redelta
1287 [ -z "$noreusedeltaopt" ] || combine_small_loose_packs $force_single_pack_redelta
1289 ! [ -e .gc_failed ] || exit 1
1290 rm -f .gc_in_progress # make sure
1291 touch .gc_in_progress # it's truly fresh
1292 rm -f bundles/* objects/pack/pack-*.bndl
1293 # These only exist for a brief time before the packs loose their _f suffix
1294 # "Push Pack Redux" does not apply to these since they were only ever present with _f
1295 rm -f objects/pack/pack-*_f.keep
1296 # This is perhaps a bit aggressive in that if we're suffering from "Push Pack Redux"
1297 # and somehow we get run again immediately after the run where "Push Pack Redux" happened
1298 # and we have garbage collection forced, there's just the barest, almost negligible,
1299 # possibility that the "Push Pack Redux" ref updates _still_ have not happened and we
1300 # should not be removing _r .keep files. None of the normal Girocco processing can
1301 # cause this. The second run of this script would have to use the force gc option
1302 # for it to even be possible in the first place. What's much more likely is that
1303 # the initial run of this script was somehow interrupted in the middle before it
1304 # could get rid of the _r .keep file itself in which case it's better to get rid of
1305 # it now to avoid keeping something around that would perturb our nice and neat gc
1306 rm -f objects/pack/pack-*_r.keep
1307 # We will add .keep files for _u and _l packs if and when we run phase III
1308 # Otherwise they need to not have any .keep files during phases I and II
1309 rm -f objects/pack/pack-*_[ul].keep
1311 # We need to make sure that any non-Girocco (barely tolerated) Git object creation
1312 # activity will be able to "freshen" the pack containing a pre-existing object
1313 # that's being written. This really should not be necessary as the pre-receive
1314 # hook should make sure this takes place for any incoming pushes.
1315 # However, do it here anyway just in case.
1316 make_packs_ugw objects/pack
1318 # This is only effective with Git v2.3.5 and later and it will only matter when
1319 # we are using one of the "internal_rev_list" modes of pack-objects
1320 # (the combine-packs.sh script never uses any of those modes)
1321 # The "git repack" and "git prune" commands always set this internally themselves
1322 # It makes no difference if there's no repository corruption
1323 GIT_REF_PARANOIA=1 && export GIT_REF_PARANOIA
1325 # All of the options we might want to use with pack-objects were supported
1326 # at some point prior to Git version v1.6.6 which is the minimum version that
1327 # Girocco now requires. Except for one (--use-bitmap-index). Several of them
1328 # are "boiler plate" options we always want to use so we bundle them up here.
1329 pkopt="--delta-base-offset --keep-true-parents --non-empty --all-progress-implied"
1330 # We want to use --include-tag, but before Git v2.10.1 it would leave out
1331 # "middle" tags (e.g. a tag of a tag of a commit would omit the tagged tag)
1332 # See http://repo.or.cz/git.git/b773ddea2cd3b08c for details
1333 # ("pack-objects: walk tag chains for --include-tag", 2016-09-07, v2.10.1)
1334 # This is not a free check as it matches all refs against refs/tags/ then
1335 # peels all the annotated tags and checks for inclusion. The situation in
1336 # which it would add a tag that was not already included by a reachability
1337 # trace that included tag starting points can only occur if a new tag gets
1338 # pushed during gc pointing to something that would have been packed anyway.
1339 # But, it could happen and, really, compared to gc as a whole it's not that
1340 # expensive to perform (provided we do not get an unconnected pack).
1341 [ -z "$var_have_git_2101" ] || pkopt="$pkopt --include-tag"
1342 pkopt="$pkopt ${quiet:---progress} $packopts"
1344 # The git pack-objects command only supports bitmaps if all objects are being
1345 # packed (the "--all" option) and the "--stdout" option is NOT being used.
1346 # Additionally, while packing, if any encountered reachable objects are
1347 # determined to be "not wanted" then no bitmap index will be written anyway.
1348 # While it is theoretically possible that a project with a non-empty alternates
1349 # file ends up packing all objects (because it does not actually use any of the
1350 # objects found in the alternates), it's very unlikely. And, in the unlikely
1351 # event that did occur, clients would see a message about only using one bitmap
1352 # because Git can only use one bitmap at a time and at least one of the
1353 # alternates is bound to have a bitmap. Therefore if we see a non-empty
1354 # alternates file, we disable writing bitmaps which avoids the warning and any
1355 # possibility of a client warning as well. Also if we are running anything
1356 # before Git v2.1.0 (the effective version for repack.writeBitmaps=true) then
1357 # we also always disable bitmap writing.
1358 wbmopt=
1359 [ -z "$var_have_git_210" ] || wbmopt="--write-bitmap-index"
1360 # More recent versions of pack-objects have optimizations when not using the
1361 # --local option. If we do not have any alternates it's a pointless option.
1362 # If we do have alternates we need to skip writing a bitmap and we cannot
1363 # have a bundle since it must contain all objects.
1364 if [ -n "$isfork" ]; then
1365 lclopt="--local"
1366 wbmopt=
1367 makebndl=
1368 else
1369 lclopt=
1370 makebndl=1
1374 ## Phase I
1377 wbmstr=
1378 [ -n "$wbmopt" ] || wbmstr=" (bitmaps disabled)"
1379 progress "~ [$proj] running primary full gc pack-objects$wbmstr ($(date))"
1381 gotforks=
1382 ! has_forks_with_alternates "$proj" || gotforks=1
1384 # To avoid "Push Pack Redux" (see docs/technical/gc.txt), after collecting the
1385 # initial preexisting non-keep pack list, we rename them so that an incoming push
1386 # pack cannot possibly experience a pack name collision. Git does not require
1387 # use of the "default" pack names, simply that the proper extensions are used.
1388 # We rename to insert an "_r" just before the extension to avoid "Push Pack Redux"
1389 # name collisions. Later on we may create an "unreachable" pack for hard-linking
1390 # down into forks and it will have an "_u" inserted just before its extension.
1391 packlist="$(list_packs -C objects/pack --all --exclude-no-idx --exclude-keep --quiet .)" || :
1392 oldpacks=
1393 for oldpack in $packlist; do
1394 oldpack="${oldpack%.pack}"
1395 [ -f "objects/pack/$oldpack.pack" ] || {
1396 echo >&2 "[$proj] unable to list old pack files"
1397 exit 1
1399 case "$oldpack" in pre-auto-gc-[12])
1400 # we never disturb pre-auto-gc-1 or pre-auto-gc-2 packs
1401 continue
1402 esac
1403 oldpackhex="${oldpack#pack-}"
1404 if [ "${oldpackhex#*[!0-9a-fA-F]}" != "$oldpackhex" ]; then
1405 # names not exclusively hexadecimal do not need renaming
1406 case "$oldpack" in
1407 pack-$octet20*_l)
1408 # _l packs are treated like still-unpacked loose objects
1409 continue;;
1410 *_f)
1411 # _f packs can only be left over from a previously interrupted gc;
1412 # they need to be renamed to _r now so they're not confused with
1413 # any freshly generated "final" packs (and we already removed
1414 # any pre-existing *_f.keep files so we're good to go)
1417 oldpacks="${oldpacks:+$oldpacks }$oldpack"
1418 continue;;
1419 esac
1421 rename_pack "objects/pack/$oldpack" "objects/pack/${oldpack%_f}_r" || {
1422 echo >&2 "[$proj] unable to rename old pack files"
1423 exit 1
1425 # If the oldpack has a .keep now it means a "Push Pack Redux" is actually
1426 # in progress at this moment and we need to .keep the renamed pack,
1427 # otherwise no "Push Pack Redux" has started yet or it has already finished.
1428 # In either case we're okay because if it's just finished then all ref
1429 # changes have already been made so we don't need a .keep and we will
1430 # see the ref changes and grab all the objects via a reachability trace.
1431 # If it hasn't started yet that's okay because we're done moving that
1432 # name so a complete pack will appear under the old name that we'll
1433 # leave alone.
1434 if [ -f "objects/pack/$oldpack.keep" ]; then
1435 echo "Push Pack Redux" >"objects/pack/${oldpack%_f}_r.keep"
1436 else
1437 oldpacks="${oldpacks:+$oldpacks }${oldpack%_f}_r"
1439 done
1441 # We wish to keep deltas from our last full pack so if we're not redeltaing
1442 # then make sure the .pack associated with the .bitmap has a newer mod time
1443 # (If there is no .bitmap then touch the pack with the most objects instead.)
1444 if [ -z "$newdeltas" ]; then
1445 bmpack="$(list_packs --exclude-no-bitmap --exclude-no-idx --max-matches 1 objects/pack)"
1446 [ -n "$bmpack" ] || bmpack="$(list_packs --exclude-no-idx --max-matches 1 --object-limit -1 --include-boundary objects/pack)"
1447 if [ -n "$bmpack" ] && [ -f "$bmpack" ] && [ -s "$bmpack" ]; then
1448 sleep 1
1449 touch -c "$bmpack" 2>/dev/null || :
1450 # We must touch .gc_in_progress here to avoid $bmpack looking
1451 # like it's been "freshened" when redundant packs are removed
1452 # It's okay if they have the same mod time, but POSIX does not
1453 # guarantee an ordering for the "touching" that occurs which is
1454 # why this must be a separate command but needs no "sleep 1"
1455 touch .gc_in_progress
1459 # Now we need to make sure that any "freshening" that takes place will actually
1460 # result in a "newer" modification time than the .gc_in_progress file now has
1461 sleep 1
1463 # We run git pack-objects from the repack subdirectory so we can force
1464 # optimized packs to be generated even for repositories that do not have any
1465 # tagged commits
1466 packs="$(git --git-dir=repack pack-objects </dev/null \
1467 $pkopt --all $newdeltas $lclopt ${wbmopt:---honor-pack-keep} "$@" repack/alt/pack/pack)"
1468 v_cnt packcnt $packs
1469 [ $packcnt -eq 1 ] || makebndl=
1472 ## Phase II
1475 progress "~ [$proj] running supplementary gc pack-objects ($(date))"
1477 # Add the "supplementary" refs
1478 compute_extra_reachables >>repack/packed-refs
1480 # Now calculate the final repack signature hash
1481 # Since we do _allow_ worktrees and we do _allow_ ref logs,
1482 # the ref logs of such must be accounted for here as well
1483 _rpksig="$(cat_all_ref_logs repack/packed-refs | sig_hash_stdin)"
1484 echo "$_rpksig" >repack/repack.sighash
1486 # Subtract the primary refs
1487 GIT_ALTERNATE_OBJECT_DIRECTORIES="$PWD/repack/alt"
1488 export GIT_ALTERNATE_OBJECT_DIRECTORIES
1490 # For this one we MUST use --local and MUST NOT use --write-bitmap-index
1491 # However, if there is a "logs" subdirectory we need to use --reflog
1492 # We do add it, just in case, if the linked working trees dir is present
1493 # We do not add --indexed-objects as that requires v2.2.0 and it's unclear
1494 # if it properly includes linked working tree index files or not. The
1495 # above compute_extra_reachables has already included all index trees (thereby
1496 # providing proper --indexed-objects support for all Git versions) making the
1497 # option completely unnecessary.
1498 rflopt=
1499 ! [ -d logs ] && ! [ -d worktrees ] || rflopt=--reflog
1500 spacks="$(git --git-dir=repack pack-objects </dev/null \
1501 $pkopt --honor-pack-keep --all $rflopt $newdeltas --local "$@" repack/alt/pack/pack)"
1504 ## Phase III
1507 # There's nothing to do for Phase III unless we have forks that refer to our
1508 # project from their alternates file
1509 hlpacks=
1510 upacks=
1511 if [ -n "$gotforks" ]; then
1513 progress "~ [$proj] running keep-unreachable gc pack-objects for forks ($(date))"
1515 # If we are a fork, any pre-existing _u packs need to have a .keep
1516 # for this phase and be added to the hlpacks list otherwise (we are
1517 # not a fork) pre-existing _u packs are anomalies to be treated like
1518 # regular non-_u packs
1519 if [ -n "$isfork" ]; then
1520 for upack in $(find -L objects/pack -mindepth 1 -maxdepth 1 -name "pack-$octet20*_[ul].pack" -print); do
1521 upack="${upack%.pack}"
1522 [ -e "$upack.keep" ] || echo "unreachable" >"$upack.keep"
1523 case "$upack" in *_l);;*)
1524 hlpacks="${hlpacks:+$hlpacks }${upack#objects/pack/pack-}"
1525 esac
1526 done
1528 # Using either --no-reuse-delta or --no-reuse-object together with the
1529 # --keep-unreachable option is a very, very, very bad idea when good
1530 # packs are the desired outcome. If newdeltas are being generated
1531 # then we pack to a temp name, and use combine-packs.sh to get a better
1532 # pack as the result to avoid making a bad --keep-unreachable pack
1533 pfx=
1534 [ -z "$newdeltas" ] || pfx="ku"
1535 upacks="$(git --git-dir=repack pack-objects </dev/null \
1536 $pkopt --honor-pack-keep --all $rflopt --keep-unreachable --local "$@" repack/alt/pack/${pfx}pack)"
1537 if [ -n "$upacks" ] && [ -n "$newdeltas" ]; then
1538 progress "~ [$proj] rebuilding keep-unreachable pack deltas"
1539 oldupacks="$upacks"
1540 upacks="$(
1541 printf "repack/alt/pack/${pfx}pack-%s.pack\n" $oldupacks |
1542 run_combine_packs --names --weak-naming --non-empty --all-progress-implied ${quiet:---progress} \
1543 $packopts $newdeltas "$@" repack/alt/pack/pack)"
1544 eval rm -f "$(printf \""repack/alt/pack/${pfx}pack-%s.*"\"" " $oldupacks)"
1546 for upack in $upacks; do
1547 rename_pack "repack/alt/pack/pack-$upack" "repack/alt/pack/pack-${upack}_u"
1548 done
1549 rm -f objects/pack/pack-*_[ul].keep
1550 [ -z "$hlpacks" ] && [ -z "$upacks" ] ||
1551 progress "~ [$proj] hard-linking keep-unreachable pack(s) into immediate child forks"
1553 # We have to update the lastparentgc time in the child forks even if they do not get any
1554 # new "unreachable packs" because they need to run gc just in case the parent now has some
1555 # objects that used to only be in the child so they can be removed from the child.
1556 # For example, a "patch" might be developed first in a fork and then later accepted into
1557 # the parent in which case the objects making up the patch in the child fork are now
1558 # redundant (since they're now in the parent as well) and need to be removed from the
1559 # child fork which can only happen if the child fork runs gc.
1560 lastparentgc="$(date "$datefmt")"
1562 # It is enough to copy objects just one level down and get_repo_list
1563 # takes a regular expression (which is automatically prefixed with '^')
1564 # so we can easily match forks exactly one level down from this project
1565 forkdir="$proj"
1566 get_repo_list "$forkdir/[^/:][^/:]*:" |
1567 while read fork; do
1568 # Ignore forks that do not exist or are symbolic links
1569 ! [ -L "$cfg_reporoot/$fork.git" ] && [ -d "$cfg_reporoot/$fork.git" ] ||
1570 continue
1571 # Or have an empty alternates file
1572 ! is_empty_alternates_file "$cfg_reporoot/$fork.git/objects/info/alternates" ||
1573 continue
1574 runupdate=
1575 # Match hlpacks in parent project if any
1576 if [ -n "$hlpacks" ]; then
1577 mkdir -p "$cfg_reporoot/$fork.git/objects/pack"
1578 eval ln -f "$(printf '"objects/pack/pack-%s.pack" ' $hlpacks)" \
1579 "$(printf '"objects/pack/pack-%s.idx" ' $hlpacks)" \
1580 '"$cfg_reporoot/$fork.git/objects/pack/"'
1581 runupdate=1
1583 # Match upacks in repack/alt area if any
1584 if [ -n "$upacks" ]; then
1585 mkdir -p "$cfg_reporoot/$fork.git/objects/pack"
1586 eval ln -f "$(printf '"repack/alt/pack/pack-%s_u.pack" ' $upacks)" \
1587 "$(printf '"repack/alt/pack/pack-%s_u.idx" ' $upacks)" \
1588 '"$cfg_reporoot/$fork.git/objects/pack/"'
1589 runupdate=1
1591 if ! [ -e "$cfg_reporoot/$fork.git/.needsgc" ]; then
1592 # Trigger a mini gc in the fork if it now has too many packs
1593 fpackcnt="$(list_packs --quiet --count --exclude-no-idx --exclude-keep "$cfg_reporoot/$fork.git/objects/pack")" || :
1594 if [ -n "$fpackcnt" ] && [ "$fpackcnt" -ge 20 ]; then
1595 >"$cfg_reporoot/$fork.git/.needsgc"
1598 [ -z "$runupdate" ] || git --git-dir="$cfg_reporoot/$fork.git" update-server-info
1599 # Update the fork's lastparentgc date (must be more recent than $gcstart)
1600 git --git-dir="$cfg_reporoot/$fork.git" config gitweb.lastparentgc "$lastparentgc"
1601 done
1604 # Now move any primary/supplementary packs back into objects/pack
1605 # then drop any "unfreshened" redundant packs and clear repack/alt
1607 # First make sure the primary pack(s) have the most recent mod time
1608 if [ -n "$packs" ]; then
1609 [ -z "$spacks" ] || sleep 1
1610 printf 'repack/alt/pack/pack-%s.pack\n' $packs | xargs touch -c 2>/dev/null || :
1613 # Move the packs into place but with a _f suffix and a .keep file for now
1614 for pack in $packs $spacks; do
1615 rename_pack "repack/alt/pack/pack-$pack" "objects/pack/pack-${pack}_f"
1616 [ -e "objects/pack/pack-${pack}_f.keep" ] ||
1617 echo "final" >"objects/pack/pack-${pack}_f.keep"
1618 done
1620 # It's possible that one of the $oldpacks had a .bitmap, got renamed (along
1621 # with its .bitmap) and then got "freshened" causing us to not remove it
1622 # However, if $wbmopt is set we most likely now have TWO .bitmap packs!
1623 # This can produce ugly warnings we don't want and possibly get the wrong
1624 # bitmap used since only one .bitmap file can ever be used by Git.
1625 # If this has happened, the .bitmap we want to discard will always have
1626 # an _r suffix so we can just zap any such now since it will leave the pack.
1627 [ -z "$wbmopt" ] || rm -f objects/pack/pack-*_r.bitmap || :
1629 # Remove the redundant packs that have not since been "freshened"
1630 # This does not completely eliminate the race condition window (Girocco's own
1631 # activites -- gc/fetch/receive are immune to the race) but it substantially
1632 # shrinks it down to just the time after the find but before the following rm
1633 >repack/oldpacks
1634 [ -z "$oldpacks" ] ||
1635 printf 'objects/pack/%s.pack\n' $oldpacks |
1636 LC_ALL=C sort >repack/oldpacks
1637 find -L objects/pack -maxdepth 1 -type f -name "pack-$octet20*.pack" -newer .gc_in_progress -print |
1638 LC_ALL=C sort >repack/freshened
1639 deadpacks="$(LC_ALL=C join -v 1 repack/oldpacks repack/freshened | LC_ALL=C sed 's/\.pack$//')"
1640 [ -z "$deadpacks" ] ||
1641 eval echo "$(printf '"%s".* ' $deadpacks)" | xargs rm -f || :
1643 # No need for this anymore
1644 rm -rf repack/alt objects/pack/repack
1645 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
1648 ## Phase IV
1651 progress "~ [$proj] running gc prune-packed"
1653 # We do not want the redundant packs or any new "--keep-unreachable" pack(s) to be
1654 # present while running prune-packed. We try to guarantee that any loose object
1655 # (or any object present in a pack with an _l suffix which was created by mini gc)
1656 # that's unreachable persists for at least one $Girocco::Config::min_gc_interval
1657 # (not withstanding administrator interference to force earlier gc to occur).
1658 # If we were to include the redundant/keep-unreachable pack(s) when running
1659 # prune-packed and a loose unreachable object happened to be duplicated in one
1660 # of them we would end up removing it too soon and void our guarantee.
1661 git prune-packed $quiet
1663 progress "~ [$proj] running loose objects gc pack-objects ($(date))"
1665 # Although Git v2.10.0 and later support a --pack-loose-unreachable option,
1666 # we MUST NOT use it for these reasons:
1667 # 1) We're not interested in expensive "unreachable" at this point, only "loose"
1668 # 2) It produces simply horrid packs about 3.8x times larger than they should be
1669 # 3) We don't require anything more than Git v1.6.6
1670 # The only way we could see any _o pack files at this point is if one got
1671 # "freshened" while we were running gc. If that happens then it gets to live on
1672 # until the next full gc and we need to include it in the loose repack here.
1673 lpacks="$(list_packs --exclude-no-idx --exclude-no-sfx _l --exclude-no-sfx _o --quiet objects/pack |
1674 run_combine_packs --replace --names --loose --weak-naming --non-empty --honor-pack-keep \
1675 --all-progress-implied ${quiet:---progress} $packopts $newdeltas "$@")"
1677 if [ -n "$lpacks" ]; then
1678 # Make sure any primary pack(s) have a more recent mod time than "unreachable" objects packs
1679 if [ -n "$packs" ]; then
1680 sleep 1
1681 printf 'objects/pack/pack-%s_f.pack\n' $packs | xargs touch -c 2>/dev/null || :
1683 # We need to identify these packs later so we don't combine_packs them
1684 for objpack in $lpacks; do
1685 rename_pack "objects/pack/pack-$objpack" "objects/pack/pack-${objpack}_o" || :
1686 done
1689 # Polish up the final packs now
1690 rm -f objects/pack/pack-*_f.keep
1691 for pack in $packs $spacks; do
1692 rename_pack "objects/pack/pack-${pack}_f" "objects/pack/pack-$pack"
1693 done
1695 if [ -n "$lpacks" ]; then
1696 # Finally zap the corresponding loose objects
1697 progress "~ [$proj] running packed loose objects gc prune-packed"
1698 git prune-packed $quiet
1701 ! [ -e .gc_failed ] || exit 1
1702 # These, if they exist, are now meaningless and need to be removed
1703 rm -f gfi-packs .needsgc .needspack .needspackgc
1705 # Make sure this stays up to date
1706 git update-server-info
1708 # We must make loose objects group writable so that they
1709 # can be freshened by other pushers. Technically we need only do this for
1710 # push projects but to enable mirror projects to be more easily converted to
1711 # push projects, we go ahead and do it for all projects.
1712 # By the time we get here we really shouldn't have any of these, but just in case.
1713 { find -L objects/$octet -type f -name "$octet19*" -exec chmod ug+w '{}' + || :; } 2>/dev/null
1715 # darcs mirrors have a xxx.log file that will grow endlessly
1716 # if this is a mirror and the file exists, shorten it to 10000 lines
1717 # also take this opportunity to optimize the darcs repo
1718 if ! [ -e .nofetch ] && [ -n "$cfg_mirror" ]; then
1719 url="$(config_get baseurl)" || :
1720 case "$url" in darcs://* | darcs+http://* | darcs+https://*)
1721 if [ -n "$cfg_mirror_darcs" ]; then
1722 url="${url%/}"
1723 basedarcs="$(basename "${url#darcs*:/}")"
1724 if [ -f "$basedarcs.log" ]; then
1725 tail -n 10000 "$basedarcs.log" >"$basedarcs.log.$$"
1726 mv -f "$basedarcs.log.$$" "$basedarcs.log"
1728 if [ -d "$basedarcs.darcs" ]; then
1730 cd "$basedarcs.darcs"
1731 # without show_progress suppress non-error output
1732 [ "${show_progress:-0}" != "0" ] || exec >/dev/null
1733 # Note that this does not optimize _darcs/inventories/ :(
1734 darcs optimize || :
1738 esac
1741 # Create a matching .bndl header file for the all-in-one pack we just created
1742 # but only if we're not a fork (otherwise the bundle would not be complete)
1743 # and we are running at least Git version 1.7.2 (pack_is_complete always fails otherwise)
1744 if [ -n "$makebndl" ] && [ -n "$var_have_git_172" ]; then
1745 # There should only be one pack in $packs but do some checking...
1746 # The one we just created will have a .idx and will NOT have a .keep
1747 progress "~ [$proj] creating downloadable bundle header"
1748 pkbase=
1749 pkhead=
1750 IFS= read -r curhead <repack/HEAD.orig || :
1752 [ -s "objects/pack/pack-$packs.pack" ] &&
1753 [ -s "objects/pack/pack-$packs.idx" ] &&
1754 ! [ -e "objects/pack/pack-$packs.keep" ] &&
1755 pkhead="$(pack_is_complete "$PWD/objects/pack/pack-$packs.pack" \
1756 "$PWD/repack/packed-refs.orig" "$curhead")"
1757 then
1758 pkbase="objects/pack/pack-$packs"
1760 if [ -n "$pkbase" ] && [ -n "$pkhead" ]; then
1762 symref=
1763 case "$curhead" in "ref: refs/"?*|"ref:refs/"?*|"refs/"?*)
1764 symref="${curhead#ref:}"
1765 symref="${symref# }"
1766 esac
1767 bndlurl=
1768 [ -z "$cfg_httpbundleurl" ] || bndlurl=" url=$cfg_httpbundleurl/$proj.git/clone.bundle"
1769 echo "# v2 git bundle"
1770 LC_ALL=C sed -ne "/^$octet20$hexdig* refs\/[^ $tab]*\$/ p" <repack/packed-refs.orig
1771 if [ -n "$symref" ]; then
1772 printf "$pkhead HEAD\0symref=HEAD:%s%s\n" "$symref" "$bndlurl"
1773 else
1774 if [ -n "$bndlurl" ]; then
1775 printf "$pkhead HEAD\0%s\n" "${bndlurl# }"
1776 else
1777 echo "$pkhead HEAD"
1780 echo ""
1781 } >"$pkbase.bndl"
1782 bndletag="$("$cfg_basedir/bin/rangecgi" --etag -m 1 "$pkbase.bndl" "$pkbase.pack")" || :
1783 bndlsha="$(printf '%s' "$bndletag" | git hash-object --stdin)" || :
1784 if [ -n "$bndletag" ]; then
1785 case "$bndlsha" in $octet20*)
1786 bndlshatrailer="${bndlsha#????????}"
1787 bndlshaprefix="${bndlsha%$bndlshatrailer}"
1788 bndlname="$(TZ=UTC date +%Y%m%d_%H%M%S)-${bndlshaprefix:-0}"
1789 [ -d bundles ] || mkdir bundles
1790 echo "${pkbase#objects/pack/}.bndl" >"bundles/$bndlname"
1791 echo "${pkbase#objects/pack/}.pack" >>"bundles/$bndlname"
1792 ln -s -f -n "$bndlname" bundles/latest
1793 esac
1798 # Record the size of this repo as the sum of its clone packed-refs + *.pack sizes as 1024-byte blocks
1799 eval "reposizek=$(( $(
1800 echo 0 $(du -k repack/packed-refs.orig $(printf 'objects/pack/pack-%s.pack ' $packs) 2>/dev/null |
1801 LC_ALL=C awk '{print $1}') |
1802 LC_ALL=C sed -e 's/ / + /g') ))"
1803 config_set_raw girocco.reposizek "${reposizek:-0}"
1805 read -r rsighash <repack/packed-refs.sighash || :
1806 read -r repacksig <repack/repack.sighash || :
1808 # Now we're finally done with this
1809 rm -rf repack
1811 # Update various "signature" hashes used to help determine whether or
1812 # not it's okay to skip gc in the future (because there's nothing to do)
1814 psighash="$(if [ -n "$packs" ] || [ -n "$spacks" ]; then
1815 printf 'pack-%s.pack\n' $packs $spacks
1816 fi | LC_ALL=C sort | sig_hash_stdin)"
1817 config_set_raw girocco.gcsig.packs "$psighash"
1818 config_set_raw girocco.gcsig.refs "$rsighash"
1819 config_set_raw girocco.gcsig.repack "$repacksig"
1821 # We use $gcstart here to avoid a race where a push occurs during the gc itself
1822 # and the next future gc could be incorrectly skipped if we used the current
1823 # timestamp here instead
1824 config_set lastgc "$gcstart"
1825 rm -f "$lockf"
1827 progress "- [$proj] garbage check ($(date))"